【力扣】17.04.消失的数字

这道题的题目意思就是从0-n中的数字中找出缺失的那一个,n是数组的长度,因此我的想法就是先将数组进行排序,往sort()里面一扔,完了以后看前一个与后一个之差中哪个不是等于1的,就求出来即可。

法一:

也就是我自己的想法

cpp 复制代码
class Solution {
public:
    int missingNumber(vector<int>& nums) {
        //首先排序,然后再找
        sort(nums.begin(),nums.end());
        for(int i=0;i<nums.size();i++){
            cout<<nums[i];
        }
        cout<<endl;
        int n=nums.size();
        //考虑最后一个数不在其中的情况
        if(nums[n-1]!=n) return n;
        //主要是考虑0-n之间的缺数的情况
        for(int i=1;i<n;i++){
            if(nums[i]-nums[i-1]!=1){
                cout<<nums[i]<<nums[i-1];
                return (nums[i]+nums[i-1])/2;
            }
        }
        return 0;
        }
        
};

还有两个方法:

  • 一个是把它扔到unordered_set里面,利用其count()方法+循环遍历看差了哪个就行
  • 以及就是我们用和之差的方式,就是求在没有缺失的情况下的S,也就是和,然后与缺失了?数字相减,即可得到
cpp 复制代码
class Solution {
public:
    int missingNumber(vector<int>& nums) {
        int miss=-1;
        unordered_set<int>set;
        int n=nums.size();
        for(int i=0;i<n;i++){
            set.insert(nums[i]);
        }
        for(int i=0;i<=n;i++){
            if(!set.count(i)){
                miss=i;
                break;
            }
        }
        return miss;
        }
        
};
相关推荐
hanlin032 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.3 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院5 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI5 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo6235 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y6 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu6 小时前
笛卡尔树
算法·图论
026d236 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生6 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生6 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构